/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 30.09.2011
Author  : Admin
Company : Microsoft
Comments: 


Chip type               : ATmega8L
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <1100.h>
#include <stdio.h> 
#include <delay.h>

// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=4
   .equ __scl_bit=5
#endasm
#include <i2c.h>



bit fflag = 1;  // 
unsigned char mode;
 
#define UP_Button    (!PINC.2)  //   
#define DOWN_Button  (!PINC.3)  //   
#define MODE_Button  (!PINC.0)  //     
#define MUTE_Button  (!PINC.1)  //   mute

//,     
#define KEY_NULL      0
 
char val = 0;

const char m_about = 0,
m_vol = 1,
m_trbl = 2,
m_bass = 3,
m_set = 4;
//m_mute = 5;

char about, vol, trbl, bass, set, mute = 0, vol_tmp;
double timer=0; 

const char vl_adr = 0b00000101,
vr_adr = 0b00000110,
t_adr = 0b00000100,
b_adr = 0b00000011,
s_adr = 0b00000001; 



flash char b_val[15] = {
0b00010000, 
0b00010001, 
0b00010010, 
0b00010011, 
0b00010100, 
0b00010101, 
0b00010110, 
0b00010111, 
0b00011110, 
0b00011101, 
0b00011100, 
0b00011011, 
0b00011010, 
0b00011001, 
0b00011000
};

flash char t_val[15] = {
0b00001110,
0b00011110,
0b00101110,
0b00111110,
0b01001110,
0b01011110,
0b01101110,
0b01111110,
0b11101110,
0b11011110,
0b11001110,
0b10111110,
0b10101110,
0b10011110,
0b10001110
}; 

flash char v_val[20] = {
0b00000000,
0b00000100,
0b00001000,
0b00001100,
0b00010000,
0b00010100,
0b00011000,
0b00011100,
0b00100000,
0b00100100,
0b00101000,
0b00101100,
0b00110000,
0b00110100,
0b00111000,
0b00111100,
0b01000000,
0b01000100,
0b01001000,
0b01001100
};

static const char v_val_t[20] = 
{0,-4,-8,-12,-16,-20,-24,-28,-32,-36,
-40,-44,-48,-52,-56,-60,-64,-68,-72,-76 };  

unsigned char Mode_Change_Enabled = 1;    //   

static const char volum[20] ={ 
0xFA,0x8C,0xF8,0x54,0x22,0x51,0xFF,0x04,0x02,0x00,
0x02,0x01,0x00,0x01,0x02,0x04,0x07,0x01,0x02,0x00   
};

//static const char trble[10] ={ 
//0xF8,0xF0,0xEC,0xCC,0x83,0x83,0xCC,0xEC,0xF0,0xF8   
//};

void tda_send(char sba, char dt)
{
   i2c_start();
   i2c_write(0b10000000);
   i2c_write(sba);
   i2c_write(dt);
   i2c_stop();
} 
eeprom char e_vol;
eeprom char e_bass;
eeprom char e_trbl;
eeprom char e_set;
// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here
TCNT1H=0;
TCNT1L=0;
sek++;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
PORTB=0x03;
DDRB=0x3C;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=P State0=P 
PORTC=0x0F;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;



// I2C Bus initialization
i2c_init();

lcd_init();
mode = 0;
vol = e_vol;
trbl = e_trbl;
bass = e_bass;
set = e_set;

lcd_clear();

//tda_send(s_adr, s_val[surr]);
tda_send(vl_adr, v_val[vol]); 
tda_send(vr_adr, v_val[vol]);
tda_send(t_adr, t_val[trbl]);
tda_send(b_adr, b_val[bass]);
tda_send(0x00, 0x00);

  
#asm("sei")
while (1)
      {
      // Place your code here 
      unsigned char i;
      unsigned char key;
      //*********************************** 
      
      //  .
       if(sek==60) //   = 60 
       {
       minut++; //  1   "" 
       sek=0; //   ""
       }
       if(minut==60) //   = 60 
       {
       hour++; //  1   "" 
       minut=0; //   ""
       }
       if (hour==24) //       24  
       { //   24 ,   .
       hour=0;
       minut=0;
       sek=0;
       }
       //   ,             .
       if (hour==255)
       hour=0;
       if (minut==255)
       minut=0;
       //***********************************
       
       //  
       if((mode != 0)&&(KEY_NULL)&&(timer < 10000)) timer = timer + 1;
       if(timer == 10000) {
       mode = 0; 
       timer = 0;
       fflag = 0;
       lcd_clear();
       }; 
       //***********************************
       
       //     
       if (MUTE_Button) {
         delay_ms(200);
          
         if (mute==0) {
         mute=1; 
         
         gotoxy(5,1);
          for ( i = 0; i != 10; i++ ){
          gotoxy(5+i, 1);
          lcd_write(DATA,volum[i]);
          gotoxy(5+i, 2);
          lcd_write(DATA,volum[10+i]);
          }  
         }
         else
         {
         mute=0;
         
         gotoxy(5,1); print_message("  ");
         gotoxy(5,2); print_message("  "); 
         };

       };
       //***********************************
       
       //
       if ((UP_Button)&&(mode==1)) {
          delay_ms(50); mute=0;
          gotoxy(5,1); print_message("  ");
          gotoxy(5,2); print_message("  ");
       
       };
       
       if ((DOWN_Button)&&(mode==1)) {
          delay_ms(50); mute=0;
          gotoxy(5,1); print_message("  ");
          gotoxy(5,2); print_message("  ");
          
       };
      //****************************************
      
      //  
      if (Mode_Change_Enabled)
        {
            if (MODE_Button)                    //     
            {   delay_ms(100); 
                if ((mode++) == 4) mode = 0;    //   
                Mode_Change_Enabled = 0;        //      
              fflag = 1;
            };
        }
        //   ,    
        else if (!MODE_Button) {Mode_Change_Enabled = 1;}; 
      //*****************************************

      //  (about)
       if ((mode == 0) && (fflag == 1)) {
       lcd_clear(); 
       
       //   
       char_12_16(hour/10,20,1);
       char_12_16(hour%10,32,1);
       char_12_16(minut/10,50,1);
       char_12_16(minut%10,62,1);
       delay_ms(20);
       
       //gotoxy(25,4); //print_message(" 220");
       //gotoxy(3,6); print_message("               ");
                           
       //gotoxy(5,6);
         // for ( i = 0; i < 10; i++ ){
          //gotoxy(5, 1);
          //lcd_write(DATA,trble[i]);
          
          //}  
       //gotoxy(15,6); print_message("-           ");
       //sprintf( TrblBuffer,"%d", trbl ); 
       //gotoxy(15,6); print_string(TrblBuffer);
             
       fflag = 0; 
       };
      //*****************************************

      //   (volum)
       if ((mode==1)&&(fflag==1)) {
       lcd_clear(); vol = vol_tmp;
        gotoxy(20,3); print_message("");
               
       //gotoxy(15,5); print_char(vol);
         //char_12_16(vol,15,5);
         if((UP_Button)&(vol < 19)) vol++;
         if((DOWN_Button)&(vol > 0)) vol--;
         tda_send(vl_adr, v_val[vol]); 
         tda_send(vr_adr, v_val[vol]); 
         //gotoxy(3,5); print_string(v_val_t);
         //e_vol = vol;
         
       fflag = 0;
       timer = 0; 
       };
      //*****************************************

      //   (trbl)
       if ((mode==2)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,3); print_message("   ");
         //gotoxy(15,5); print_char(trbl);
         //char_12_16('00',15,5);
         if((UP_Button)&(trbl < 14)) trbl++;
         if((DOWN_Button)&(trbl > 0)) trbl--;
         tda_send(t_adr, t_val[trbl]);
       
       fflag = 0;
       timer = 0; 
       };
       //*****************************************

      //   (bass)
       if ((mode==3)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,3); print_message("   ");
         //gotoxy(3,6); print_char(bass); 
         if((UP_Button)&(bass < 14)) bass++;
         if((DOWN_Button)&(bass > 0)) bass--;
         tda_send(b_adr, b_val[bass]);
       
       fflag = 0;
       timer = 0; 
       };
      //*****************************************
      
      //  (set)
       if ((mode==4)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,2); print_message(" ");
         gotoxy(25,3); print_message(" ");
         gotoxy(30,6); print_message("00 00");
         
       fflag = 0;
       timer = 0; 
       }; 
       

       
      
     };
}
