/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 30.09.2011
Author  : Admin
Company : Microsoft
Comments: 


Chip type               : ATmega8L
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


//****************************************************************************
//NOKIA LCD 
//Function libruary                                                           
//Build by Panda
//Based on source from http://www.sunbizhosting.com/~spiral/
//19.04.2009
//****************************************************************************



sfrb LCD_PORT=0x18; 
sfrb LCD_PORT=0x18; 



void lcd_init(void);
void lcd_write(char cd,unsigned char c);
void lcd_clear(void);
void setx(char x);
void sety(char y);
void gotoxy(char x,char y);
void vline(char x,char y,char on);
void line(unsigned char x,unsigned char y,unsigned char y2,unsigned char on);
void print_message(flash char* message);
void print_char(char c);
void print_invert_char(char c);
void print_string(char * message);
void char_12_16(const char c,char x, char y);
void print_invert_message(flash char * message); 
//void char_24_32(char c,char x, char y);
//void char_12_16(char c,char x, char y);
//void print_msg(flash char * message); //invert print
//void LCD_pixel (unsigned char x, unsigned char y, unsigned char color); //++  .      
//void LCD_line ( char x1, char y1, char x2, char y2, char mode ); // ++  , mode=1 - , 0 -  
//void LCD_rectangle(char x, char y, char x1, char y1,unsigned char color);  //  ++  color =1 - , 0 - 

#pragma library 1100.lib
// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-


// I2C Bus functions
#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=4
   .equ __scl_bit=5
#endasm
/*
  CodeVisionAVR C Compiler
  (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

  Prototypes for I2C bus master functions

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE I2C BUS IS CONNECTED AND
  THE DATA BITS USED FOR SDA & SCL

  EXAMPLE FOR PORTB:

    #asm
        .equ __i2c_port=0x18
        .equ __sda_bit=3
        .equ __scl_bit=4
    #endasm
    #include <i2c.h>
*/


#pragma used+
#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-





bit fflag = 1;  // 
unsigned char mode;
 

//,     
 
char val = 0;

const char m_about = 0,
m_vol = 1,
m_trbl = 2,
m_bass = 3,
m_set = 4;
//m_mute = 5;

char about, vol, trbl, bass, set, mute = 0, vol_tmp;
double timer=0; 

const char vl_adr = 0b00000101,
vr_adr = 0b00000110,
t_adr = 0b00000100,
b_adr = 0b00000011,
s_adr = 0b00000001; 



flash char b_val[15] = {
0b00010000, 
0b00010001, 
0b00010010, 
0b00010011, 
0b00010100, 
0b00010101, 
0b00010110, 
0b00010111, 
0b00011110, 
0b00011101, 
0b00011100, 
0b00011011, 
0b00011010, 
0b00011001, 
0b00011000
};

flash char t_val[15] = {
0b00001110,
0b00011110,
0b00101110,
0b00111110,
0b01001110,
0b01011110,
0b01101110,
0b01111110,
0b11101110,
0b11011110,
0b11001110,
0b10111110,
0b10101110,
0b10011110,
0b10001110
}; 

flash char v_val[20] = {
0b00000000,
0b00000100,
0b00001000,
0b00001100,
0b00010000,
0b00010100,
0b00011000,
0b00011100,
0b00100000,
0b00100100,
0b00101000,
0b00101100,
0b00110000,
0b00110100,
0b00111000,
0b00111100,
0b01000000,
0b01000100,
0b01001000,
0b01001100
};

static const char v_val_t[20] = 
{0,-4,-8,-12,-16,-20,-24,-28,-32,-36,
-40,-44,-48,-52,-56,-60,-64,-68,-72,-76 };  

unsigned char Mode_Change_Enabled = 1;    //   

static const char volum[20] ={ 
0xFA,0x8C,0xF8,0x54,0x22,0x51,0xFF,0x04,0x02,0x00,
0x02,0x01,0x00,0x01,0x02,0x04,0x07,0x01,0x02,0x00   
};

//static const char trble[10] ={ 
//0xF8,0xF0,0xEC,0xCC,0x83,0x83,0xCC,0xEC,0xF0,0xF8   
//};

void tda_send(char sba, char dt)
{
   i2c_start();
   i2c_write(0b10000000);
   i2c_write(sba);
   i2c_write(dt);
   i2c_stop();
} 
eeprom char e_vol;
eeprom char e_bass;
eeprom char e_trbl;
eeprom char e_set;
// Timer 1 output compare A interrupt service routine
interrupt [7] void timer1_compa_isr(void)
{
// Place your code here
TCNT1H=0;
TCNT1L=0;
sek++;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=P State0=P 
PORTB=0x03;
DDRB=0x3C;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=P State0=P 
PORTC=0x0F;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x10;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;



// I2C Bus initialization
i2c_init();

lcd_init();
mode = 0;
vol = e_vol;
trbl = e_trbl;
bass = e_bass;
set = e_set;

lcd_clear();

//tda_send(s_adr, s_val[surr]);
tda_send(vl_adr, v_val[vol]); 
tda_send(vr_adr, v_val[vol]);
tda_send(t_adr, t_val[trbl]);
tda_send(b_adr, b_val[bass]);
tda_send(0x00, 0x00);

  
#asm("sei")
while (1)
      {
      // Place your code here 
      unsigned char i;
      unsigned char key;
      //*********************************** 
      
      //  .
       if(sek==60) //   = 60 
       {
       minut++; //  1   "" 
       sek=0; //   ""
       }
       if(minut==60) //   = 60 
       {
       hour++; //  1   "" 
       minut=0; //   ""
       }
       if (hour==24) //       24  
       { //   24 ,   .
       hour=0;
       minut=0;
       sek=0;
       }
       //   ,             .
       if (hour==255)
       hour=0;
       if (minut==255)
       minut=0;
       //***********************************
       
       //  
       if((mode != 0)&&(0)&&(timer < 10000)) timer = timer + 1;
       if(timer == 10000) {
       mode = 0; 
       timer = 0;
       fflag = 0;
       lcd_clear();
       }; 
       //***********************************
       
       //     
       if ((!PINC.1)  ) {
         delay_ms(200);
          
         if (mute==0) {
         mute=1; 
         
         gotoxy(5,1);
          for ( i = 0; i != 10; i++ ){
          gotoxy(5+i, 1);
          lcd_write(1,volum[i]);
          gotoxy(5+i, 2);
          lcd_write(1,volum[10+i]);
          }  
         }
         else
         {
         mute=0;
         
         gotoxy(5,1); print_message("  ");
         gotoxy(5,2); print_message("  "); 
         };

       };
       //***********************************
       
       //
       if (((!PINC.2)  )&&(mode==1)) {
          delay_ms(50); mute=0;
          gotoxy(5,1); print_message("  ");
          gotoxy(5,2); print_message("  ");
       
       };
       
       if (((!PINC.3)  )&&(mode==1)) {
          delay_ms(50); mute=0;
          gotoxy(5,1); print_message("  ");
          gotoxy(5,2); print_message("  ");
          
       };
      //****************************************
      
      //  
      if (Mode_Change_Enabled)
        {
            if ((!PINC.0)  )                    //     
            {   delay_ms(100); 
                if ((mode++) == 4) mode = 0;    //   
                Mode_Change_Enabled = 0;        //      
              fflag = 1;
            };
        }
        //   ,    
        else if (!(!PINC.0)  ) {Mode_Change_Enabled = 1;}; 
      //*****************************************

      //  (about)
       if ((mode == 0) && (fflag == 1)) {
       lcd_clear(); 
       
       //   
       char_12_16(hour/10,20,1);
       char_12_16(hour%10,32,1);
       char_12_16(minut/10,50,1);
       char_12_16(minut%10,62,1);
       delay_ms(20);
       
       //gotoxy(25,4); //print_message(" 220");
       //gotoxy(3,6); print_message("               ");
                           
       //gotoxy(5,6);
         // for ( i = 0; i < 10; i++ ){
          //gotoxy(5, 1);
          //lcd_write(DATA,trble[i]);
          
          //}  
       //gotoxy(15,6); print_message("-           ");
       //sprintf( TrblBuffer,"%d", trbl ); 
       //gotoxy(15,6); print_string(TrblBuffer);
             
       fflag = 0; 
       };
      //*****************************************

      //   (volum)
       if ((mode==1)&&(fflag==1)) {
       lcd_clear(); vol = vol_tmp;
        gotoxy(20,3); print_message("");
               
       //gotoxy(15,5); print_char(vol);
         //char_12_16(vol,15,5);
         if(((!PINC.2)  )&(vol < 19)) vol++;
         if(((!PINC.3)  )&(vol > 0)) vol--;
         tda_send(vl_adr, v_val[vol]); 
         tda_send(vr_adr, v_val[vol]); 
         //gotoxy(3,5); print_string(v_val_t);
         //e_vol = vol;
         
       fflag = 0;
       timer = 0; 
       };
      //*****************************************

      //   (trbl)
       if ((mode==2)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,3); print_message("   ");
         //gotoxy(15,5); print_char(trbl);
         //char_12_16('00',15,5);
         if(((!PINC.2)  )&(trbl < 14)) trbl++;
         if(((!PINC.3)  )&(trbl > 0)) trbl--;
         tda_send(t_adr, t_val[trbl]);
       
       fflag = 0;
       timer = 0; 
       };
       //*****************************************

      //   (bass)
       if ((mode==3)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,3); print_message("   ");
         //gotoxy(3,6); print_char(bass); 
         if(((!PINC.2)  )&(bass < 14)) bass++;
         if(((!PINC.3)  )&(bass > 0)) bass--;
         tda_send(b_adr, b_val[bass]);
       
       fflag = 0;
       timer = 0; 
       };
      //*****************************************
      
      //  (set)
       if ((mode==4)&&(fflag==1)) {
       lcd_clear();
         gotoxy(20,2); print_message(" ");
         gotoxy(25,3); print_message(" ");
         gotoxy(30,6); print_message("00 00");
         
       fflag = 0;
       timer = 0; 
       }; 
       

       
      
     };
}
